--- old/usr/src/lib/libzfs/common/libzfs_sendrecv.c	2012-10-26 17:09:23.548926000 +0200
+++ new/usr/src/lib/libzfs/common/libzfs_sendrecv.c	2012-10-26 17:09:23.556926000 +0200
@@ -789,7 +789,7 @@
 	char prevsnap[ZFS_MAXNAMELEN];
 	uint64_t prevsnap_obj;
 	boolean_t seenfrom, seento, replicate, doall, fromorigin;
-	boolean_t verbose, dryrun, parsable, progress;
+	boolean_t verbose, dryrun, parsable, progress, far;
 	int outfd;
 	boolean_t err;
 	nvlist_t *fss;
@@ -868,7 +868,7 @@
  */
 static int
 dump_ioctl(zfs_handle_t *zhp, const char *fromsnap, uint64_t fromsnap_obj,
-    boolean_t fromorigin, int outfd, nvlist_t *debugnv)
+    boolean_t fromorigin, int outfd, int far, nvlist_t *debugnv)
 {
 	zfs_cmd_t zc = { 0 };
 	libzfs_handle_t *hdl = zhp->zfs_hdl;
@@ -882,6 +882,7 @@
 	zc.zc_obj = fromorigin;
 	zc.zc_sendobj = zfs_prop_get_int(zhp, ZFS_PROP_OBJSETID);
 	zc.zc_fromobj = fromsnap_obj;
+	zc.zc_guid = far ? 2 : 0;
 
 	VERIFY(0 == nvlist_alloc(&thisdbg, NV_UNIQUE_NAME, 0));
 	if (fromsnap && fromsnap[0] != '\0') {
@@ -1169,7 +1170,7 @@
 		}
 
 		err = dump_ioctl(zhp, sdd->prevsnap, sdd->prevsnap_obj,
-		    fromorigin, sdd->outfd, sdd->debugnv);
+		    fromorigin, sdd->outfd, sdd->far, sdd->debugnv);
 
 		if (sdd->progress) {
 			(void) pthread_cancel(tid);
@@ -1461,7 +1462,7 @@
 			}
 		}
 
-		if (!flags->dryrun) {
+		if (!flags->dryrun && !flags->far) {
 			/* write first begin record */
 			drr.drr_type = DRR_BEGIN;
 			drr.drr_u.drr_begin.drr_magic = DMU_BACKUP_MAGIC;
@@ -1520,6 +1521,7 @@
 	sdd.parsable = flags->parsable;
 	sdd.progress = flags->progress;
 	sdd.dryrun = flags->dryrun;
+	sdd.far = flags->far;
 	sdd.filter_cb = filter_func;
 	sdd.filter_cb_arg = cb_arg;
 	if (debugnvp)
@@ -1581,8 +1583,8 @@
 		sdd.cleanup_fd = -1;
 	}
 
-	if (!flags->dryrun && (flags->replicate || flags->doall ||
-	    flags->props)) {
+	if (!flags->dryrun && !flags->far &&
+	    (flags->replicate || flags->doall || flags->props)) {
 		/*
 		 * write final end record.  NB: want to do this even if
 		 * there was some error, because it might not be totally
